#define SIGEL_USE_ONLY


#define SIGEL_DEVIL
//#define SIGEL_SOUND
//#define SIGEL_SCRIPT
//#define SIGEL_PHYSX
//#define SIGEL_NETWORK

#include <sigel/ISigel.h>


sGAME
{
	debug::startlog();
	InitDemo();
	AppTitle("TestMd2");

	VWait(0);
	CameraHelper ch;

	TFont *fnt = new TFont("tahoma.txt");

	Texture *k6 = new Texture("k6.jpg",TF_MIPMAP);
	Texture *tsolider = new Texture("solider.pcx",TF_MIPMAP,GL_REPLACE);

	Md2Model *md2solider = new Md2Model("solider.md2");

	Shader *md2 = new Shader("md2");
	md2->WriteInt("tex",0);

	int al = md2->GetAttribLocation("rm_NextVert");
	debug::Log<<"attrib locaton:"<<al<<std::endl;

	//md2->WriteAttribLocation("rm_NextVert",4);
	int cntx = 40;
	int cntz = 25;

	int cnt = cntx * cntz;

	Entity **ent = new Entity*[cnt];

	for(int i=0;i<cntx;++i)
	{
		for(int j=0;j<cntz;++j)
		{
			int ind = i*cntz + j;

			ent[ind] = new Entity(md2solider);
			ent[ind]->BindTex(tsolider,0);

			ent[ind]->Position(i*10,5,j*10);
			ent[ind]->Animate(0,(float)md2solider->GetTotalFrames()-1,0.1f);

			ent[ind]->SetFrame(rnd(1,200));
			ent[ind]->Scale(0.2f,0.2f,0.2f);

			ent[ind]->BindShader(md2);
		}
	}

	Surface *splane = new Surface();
	splane->MakeQuad(400.0f,10.0f);

	Entity *plane = new Entity(splane);
	plane->BindTex(k6);
	plane->Position(200.0f,0,70.0f);

	ch.GetCam()->Position(0,50,0);

	debug::Log<<"geomsize:"<<md2solider->GetSize()<<std::endl;

	md2solider->SetRenderMode(3);

	while(!KeyDown(VK_ESCAPE))
	{
		if(KeyDown(VK_F1))
		{
			md2solider->SetRenderMode(1);
			for(int i=0;i<cnt;++i)
				ent[i]->BindShader(0);
		}
		if(KeyDown(VK_F2))
		{
			md2solider->SetRenderMode(2);
			for(int i=0;i<cnt;++i)
				ent[i]->BindShader(0);
		}
		if(KeyDown(VK_F3))
		{
			md2solider->SetRenderMode(3);
			for(int i=0;i<cnt;++i)
				ent[i]->BindShader(md2);
		}

		//3d
		__int64 a = sMillisecs();

		ch.Update();
		Render();
		//2d


		fnt->Text(GetFPS(),10,10);
		fnt->Text(RenderedTris(),10,25);
		Flip();

		a = sMillisecs()-a;

		AnimUpdate((float)a * 0.0001f * (KeyDown(VK_SHIFT)?0.05f:1.0f));
	}

	DeInit();
	debug::endlog();
};